Subject: Re: [PATCH][RFC] etherip: Ethernet-in-IPv4 tunneling

From: Ben Greear <[email-masked]>
Date: Wed, 12 Jan 2005 15:43:52 -0800

Lennert Buytenhek wrote:
> On Wed, Jan 12, 2005 at 03:11:40PM -0800, Ben Greear wrote:
> 
> 
>>>>Also, could you add an ioctl that allowed one to query whether or not
>>>>a particular device is an etherip device?  I had always wished I had added
>>>>this earlier to the VLAN code :)
>>>
>>>Hmmm.  Bridge devices don't have this either, do they?  Can you name
>>>an advantage of having this?
>>
>>I got the request several times with regard to VLANs.  Lots of people
>>(and applications) will want to know the interface type for various
>>reasons.  If you don't give them a nice programatic thing like an
>>IOCTL to call, they will undoubtedly start making assumptions based
>>off of the device name...
> 
> 
> Makes sense..
> 
> Unfortunately SIOCGETTUNNEL is (SIOCDEVPRIVATE + 3), otherwise we could
> just say something like "If an ARPHRD_ETHER device supports SIOCGETTUNNEL,
> it's an ether/ip tunnel."
> 
> Any better ideas?  I hate adding more ioctls.

How about add one IOCTL that takes a small (naturally packed/aligned, fixed-size!)
struct that has within it an enumeration of specific commands and whatever fields
are needed for arguments.  Then you only need to add a single IOCTL to the system,
and you can add more commands at will.

Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com